!to "cycles.prg", CBM

;-
VECTR    = $FB
VECTR2   = $FD
;-

;NTSC 65 CYCLES PER LINE 262 SCANLINES
;IT 17030 CYCLES /DIV2 = 8515 = $2143
;OR 65 CYCLES PER LINE 263 SCANLINES
;IT 17095 CYCLES /DIV2 = 8547 = $2163

;PAL 63 CYCLES PER LINE 312 SCANLINEC
;IT 19656 CYCLES  /DIV2 = 9828 =$2664


;===========================
;=== basiline 0 sys 2061 ===
;===========================
          *=$0801
     !byte $0b,$08,$00,$00,$9e,$32
     !byte $30,$36,$31,$00,$00,$00
;-------------
			cld
			lda $ba
			cmp #$08
			bcs +
-			lda #$08
+			cmp #12
			bcs -
			sta $ba
;-
			JSR $FF5B
;-
			jsr listen
			lda #$49
			jsr $ffa8
			jsr $ffae
			
			SEI

			LDA #$0B
			STA $D011
			LDA #$00
			STA $D015
			LDA $D012
			CMP $D012
			BEQ *-3
			BMI *-8
			AND #$03
			TAX
			DEX
			TXA
			AND #3
			TAX
			STA MY_NTSC
			LDA BAS_LO,X
			STA BASE
			LDA BAS_HI,X
			STA BASE+1
;-
			ldy #$00
			sty $fb
			lda #$40
			sta $fc
			lda #$ea
			ldx #$30
-			sta ($fb),y
			iny
			bne -
			inc $fc
			dex
			bne -
			LDY #0
			LDX MY_NTSC
			LDA ADR_LO,X
			STA $FB
			LDA ADR_HI,X
			clc
			ADC #$40
			STA $FC
			
			lda #$60
			sta ($FB),Y
;-
;M-W 
;-  
			LDX #3
-			LDA VECTORS,X
			STA VECTR,X
			DEX
			BPL -
;----------------
			LDX #3
LOOP			JSR listen
			LDA #$4D
			JSR $FFA8
			LDA #$2D
			JSR $FFA8
			LDA #$57
			JSR $FFA8
			LDA VECTR
			JSR $FFA8
			LDA VECTR+1
			JSR $FFA8
			LDA #$20
			JSR $FFA8
			LDY #$00
-			LDA (VECTR2),Y
			JSR $FFA8
			INY
			CPY #$20
			BNE -
			JSR $FFAE
			LDA VECTR
			CLC
			ADC #$20
			STA VECTR
			BCC *+4
			INC VECTR+1
			LDA VECTR2
			CLC
			ADC #$20
			STA VECTR2
			BCC *+4
			INC VECTR2+1
			DEX
			BNE LOOP
;-
			JSR listen
			;LDX #$00
			LDA MEX1,X
			JSR $FFA8
			INX
			CPX #$05
			BNE *-9
			JSR $FFAE
			SEI
			LDA #$23
			STA $DD00

			BIT $DD00
			BVS *-3

;---------------
			BIT $DD00
			BVC *-3
			
			LDX #$22
			dex
			BNE *-1
			
			LDA #3
			STA $DD00

			JSR $4009
			
			LDA #$23
			STA $DD00
			
			LDX #0
			dex
			BNE *-1

			
			LDA $BA
			JSR $FFB1
			LDA #$6F
			JSR $FF93
			LDX #0
-			LDA M_RD,X
			JSR $FFA8
			INX
			CPX #6
			BNE -
			JSR $FFAE
			LDA $BA
			JSR $FFB4
			LDA #$6F
			JSR $FF96
			JSR $FFA5
			STA LOW
			JSR $FFA5
			STA HIGH
			JSR $FFAB

			LDA #<INFO1
			LDY #>INFO1
			JSR $AB1E
			LDX MY_NTSC
			LDA TX_HI,X
			TAY
			LDA TX_LO,X
			JSR $AB1E
			LDA #$0D
			JSR $FFD2
			JSR $FFD2
			JSR $FFD2
			LDA #<INFO5
			LDY #>INFO5
			JSR $AB1E
			
			LDX BASE
			LDA BASE+1
			JSR $BDCD
			LDA #$0D
			JSR $FFD2
			JSR $FFD2
			LDA #<INFO2
			LDY #>INFO2
			JSR $AB1E
			LDX LOW
			LDA HIGH
			JSR $BDCD
			LDA #$0D
			JSR $FFD2
			JSR $FFD2
			JSR $FFD2
			JSR $FFD2
			
			LDA #<INFO3
			LDY #>INFO3
			JSR $AB1E
			LDX MY_NTSC
			LDA SIGN,X
			JSR $FFD2
			LDA OPT_HI,X
			PHA
			LDA OPT_LO,X
			TAX
			PLA
			JSR $BDCD
			LDA #$0D
			JSR $FFD2
			JSR $FFD2

			LDA #<INFO4
			LDY #>INFO4
			JSR $AB1E
			
			LDA LOW
			SEC
			SBC BASE
			STA RESULT
			LDA HIGH
			SBC BASE+1
			STA RESULT+1
			
			LDA RESULT+1
			BPL +
			EOR #$FF
			STA RESULT+1
			LDA #"-"
			JSR $FFD2
			LDA RESULT
			EOR #$FF
			STA RESULT
			INC RESULT
			BNE +
			INC RESULT+1
			
+			LDX RESULT
			LDA RESULT+1
			JSR $BDCD
			
			LDA #$0D
			JSR $FFD2
			JSR $FFD2
			JSR $FFD2
			JSR $FFD2
						
			LDA #$1B
			STA $D011
			CLI
			RTS
			

;---------------------------
listen
			lda #$00
			sta $90
			lda $ba
			jsr $ffb1
			lda #$6f
			jsr $ff93
			bit $90
			bmi +
			rts
+			ldx #5
			jmp ($0300)
;------------------------			


;==================
RESULT
!BYTE 0
BASE
!BYTE 0,0
LOW
!BYTE 0
HIGH
!BYTE 0

MY_NTSC
!BYTE 0

OPT_LO
!BYTE <383
!BYTE <385
!BYTE <290
OPT_HI
!BYTE >383
!BYTE >385
!BYTE >290

SIGN
!TEXT "-- "

BAS_LO
!BYTE <17030
!BYTE <17095
!BYTE <19656


BAS_HI
!BYTE >17030
!BYTE >17095
!BYTE >19656

ADR_LO
!BYTE <$2143
!BYTE <$2163
!BYTE <$2663

ADR_HI
!BYTE >$2143
!BYTE >$2163
!BYTE >$2663

TX_LO
!BYTE <MODEL0
!BYTE <MODEL1
!BYTE <MODEL2
TX_HI
!BYTE >MODEL0
!BYTE >MODEL1
!BYTE >MODEL2


;---------------
VECTORS
!BYTE <DRV, >DRV, <ADRDRV, >ADRDRV
;-
MEX1     !text "M-E"
         !byte <ABSRUN,>ABSRUN
;-
M_RD
!text "M-R"
!byte <DATA1,>DATA1, $02
;-------------------------
INFO1 
!BYTE 5
!TEXT "C64 MODEL : "
!BYTE 0

INFO2
!TEXT "DRIVE RUN CYCLES : "
!BYTE 0

INFO3
!TEXT "OPTIMAL CYCLE DIFFERENCE : "
!BYTE 0

INFO4
!TEXT "DRIVE CYCLES - C64 CYCLES : "
!BYTE 0

INFO5
!TEXT "C64 FRAME CYCLES : "
!BYTE 0

MODEL0
!TEXT "NTSC 262 SCANLINES"
!BYTE 0
MODEL1
!TEXT "NTSC 263 SCANLINES"
!BYTE 0
MODEL2
!TEXT "PAL 312 SCANLINES"
!BYTE 0
;=========================================================
;-
ADRDRV
;-
!PSEUDOPC $0300
;----------------------------
DATA1 = $06
DRV
ABSRUN
			sei
			LDA #$7A
			STA $1802
			LDA #$08
			STA $1800

			LDY #$10
			DEX
			BNE *-1
			DEY
			BNE *-4

			LDA #$00
			STA $1800
			LDA $1800
			BNE *-3

			lda #$ff
			STA $1804
			STA $1805

			LDA $1800
			BEQ *-3
			LDY $1805
			lda $1804
			CLC
			ADC #4
			EOR #$FF
			STA $06
			tya
			EOR #$FF
			STA $07
			INC $06
			BNE +
			INC $07
+			cli
			RTS
;----------------------------
;-
         !text "(C) BY WEGI"
;-		
DUM

!REALPC

;=========================================================
